/**********************************************************************
 
	Copyright (C) 2005- Hirohisa MORI <joshua@nichibun.ac.jp>
 
	This program is free software; you can redistribute it 
	and/or modify it under the terms of the GLOBALBASE 
	Library General Public License (G-LGPL) as published by 

	http://www.globalbase.org/
 
	This program is distributed in the hope that it will be 
	useful, but WITHOUT ANY WARRANTY; without even the 
	implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE.

**********************************************************************/

#ifndef ___MX_FORMAT_H___
#define ___MX_FORMAT_H___

#include	"resource.h"
#include	"matrix.h"


typedef struct create_param {
	MATRIX *		m;
	int			mode;
	MATRIX_PARAM		p;
} CREATE_PARAM;

typedef struct create_work {
	MATRIX *		mtx;
	int			mode;
	char			pri_active[MI_MODE_MAX];
	int			pri[MI_MODE_MAX][MI_MAX];
	char			phase_active[MI_MODE_MAX];
	XL_SEXP *		phase[MI_MODE_MAX][MI_MAX];
} CREATE_WORK;

typedef struct matrix_param_work {
	MATRIX_PARAM		p;
	CREATE_WORK *		cw;
} MATRIX_PARAM_WORK;
#define MXEM_CREATE	0
#define MXEM_EXIST	1

XL_SEXP * gb_gmxCreate();
XL_SEXP * gb_gmxMatrixParam();
XL_SEXP * gb_gmxPriority();
XL_SEXP * gb_gmxMatrixDimDivide();
XL_SEXP * gb_gmxMatrixBlockSize();
XL_SEXP * gb_gmxMatrixPixelSize();
XL_SEXP * gb_gmxChannelInfo();
XL_SEXP * gb_gmxPhase();
XL_SEXP *
gb_gmxCreate_matrix(CREATE_PARAM * cp,XLISP_ENV * env,XL_SEXP * s,XLISP_ENV * a,XL_SYM_FIELD * sf);
void init_gmx_format(XLISP_ENV *);
void
init_resource_matrix();
int
insert_resource_matrix(RESOURCE * r,int w_flag);
void
gc_resource_matrix();

#endif

